/**
 * JavaScript for Terus RAG block.
 *
 * @module     block_terusrag/raginterface
  * @copyright  2025 Khairu Aqsara <khairu@teruselearning.co.uk>
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define("block_terusrag/raginterface",["core/ajax","core/notification","core/str"],(function(Ajax,Notification,Str){var RAGInterface={},SELECTORS_FORM=".rag-form",SELECTORS_QUERY_INPUT='[data-region="query-input"]',SELECTORS_RESPONSE_CONTENT='[data-region="response-content"]',SELECTORS_RESPONSE_TEXT='[data-region="response-text"]',SELECTORS_RESPONSE_METADATA='[data-region="response-metadata"]',SELECTORS_LOADING_INDICATOR='[data-region="loading-indicator"]',SELECTORS_PLACEHOLDER='[data-region="placeholder"]';return RAGInterface.init=function(selector){const container=document.querySelector(selector);if(!container)return;container.querySelector(SELECTORS_FORM).addEventListener("submit",(function(e){e.preventDefault();const query=container.querySelector(SELECTORS_QUERY_INPUT).value.trim();query&&RAGInterface.submitQuery(container,query)}))},RAGInterface.submitQuery=function(container,query){const courseId=container.dataset.courseid,loadingIndicator=container.querySelector(SELECTORS_LOADING_INDICATOR),responseContent=container.querySelector(SELECTORS_RESPONSE_CONTENT),responseText=container.querySelector(SELECTORS_RESPONSE_TEXT),responseMetadata=container.querySelector(SELECTORS_RESPONSE_METADATA),queryInputField=container.querySelector(SELECTORS_QUERY_INPUT),contentPlaceholder=container.querySelector(SELECTORS_PLACEHOLDER);console.log("Query input found:",queryInputField),loadingIndicator.classList.remove("hidden"),contentPlaceholder.classList.add("hidden"),responseText.textContent="",responseMetadata.textContent="",responseContent.classList.remove("hidden"),Ajax.call([{methodname:"block_terusrag_submit_query",args:{query:query,courseid:courseId},done:function(response){queryInputField?(queryInputField.value="",console.log("Input field cleared")):console.error("Query input field not found for clearing"),loadingIndicator.classList.add("hidden"),response.answer&&Array.isArray(response.answer)?responseText.innerHTML=response.answer.map((function(item){return'\n                            <div class="rag-response-item mb-3">\n                                <h4 class="rag-response-title">\n                                    <a href="'.concat(item.viewurl,'" target="_blank">').concat(item.title,'</a>\n                                </h4>\n                                <div class="rag-response-content" data-content-id="').concat(item.id,'">\n                                    ').concat(item.content,"\n                                </div>\n                            </div>\n                        ")})).join(""):responseText.innerHTML="<p>No results found.</p>",responseMetadata.classList.remove("hidden"),void 0!==response.promptTokenCount&&void 0!==response.responseTokenCount&&void 0!==response.totalTokenCount?Str.get_string("token_usage","block_terusrag",{prompt:response.promptTokenCount,response:response.responseTokenCount,total:response.totalTokenCount}).then((function(str){responseMetadata.innerHTML=str})).catch(Notification.exception):responseMetadata.innerHTML='<div class="token-info">No token information available</div>'},fail:function(error){console.error("Query submission failed:",error),Notification.exception(error)}}])},RAGInterface}));

//# sourceMappingURL=raginterface.min.js.map